
%  The state space model is formalized as:
%
%   y(t) = A*xy(t) + H*S(t) + w(t)  -  observation equation,  Var(w(t))=R 
%                                     
% 
%   S(t) = G*xs(t)+ F*S(t-1) + v(t)   -  state equation. Var(v(t))=Q
%
%
%   Input: parameter vector, calibrated parameters/ratio
%
%   Output: coefficient matrix A, H, R, G, F, Q


function [A,H,R,G,F,Q]=Cmat_s3(param, lam_z)


%******************Parameters*****************************************

% param0_s1=[a1 a2 a3 b1 b2 b3 b4 b5 c sig1 sig2 sig4];
a1=param(1); a2=param(2); a3=param(3); b1=param(4); b2=param(5);
b3=param(6); b4=param(7);  c=param(8);  
sig1=param(9); sig2=param(10); sig4=param(11); sig5=param(12);

% psi=exp(psia)/(1+exp(psia));
% 
% sigy=ratio1*sigz;  theta_r=ratio2*theta_y;

%****************Construct Coefficient Matrix*************************

H=[1 -a1 -a2  -c*a3/2 -c*a3/2 -a3/2 -a3/2;
   0 -b3 0   0  0          0       0   ];

A=[a1 a2 a3/2 a3/2 0 0 0 0;     
   b3 0 0 0 b1 b2 1-b1-b2 b4];

R=[sig1^2 0; 
   0 sig2^2];

G=[0;
   0;
   0;
   0;
   0;
   0;
   0];

F=[1 0  0 1 0 0 0; 
   1 0  0 0 0 0 0; 
   0 1 0 0 0 0 0 ;
   0 0 0 1 0 0 0 ;
   0 0 0 1 0 0 0 ;
   0 0 0 0 0 1 0 ;
   0 0 0 0 0 1 0];

% Q=[(1+lam_g^2)*sig4^2 0 0 (lam_g*sig4)^2 0 0 0;      
%    0 0 0 0 0 0 0;    
%    0 0 0 0 0 0 0;
%    (lam_g*sig4)^2 0 0 (lam_g*sig4)^2 0 0 0;
%    0 0 0 0 0 0 0;
%    0 0 0 0 0 (lam_z*sig1/a3)^2 0;
%    0 0 0 0 0 0 0];

Q=[sig4^2+sig5^2 0 0 sig5^2 0 0 0;      
   0 0 0 0 0 0 0;    
   0 0 0 0 0 0 0;
   sig5^2 0 0 sig5^2 0 0 0;
   0 0 0 0 0 0 0;
   0 0 0 0 0 (lam_z*sig1/a3)^2 0;
   0 0 0 0 0 0 0];


















