function [stT, ptTb] = KALSMOO(stt,st1,pttb,pt1b,F)
%*********************************************
%
%   run Kalman smoother (starting backwards)
%
%   variables:
%   stT = s(t|T)
%   ptT = p(t|T)
%
[sst nt] = size(stt);

stT = zeros(sst,nt);

stT(:,nt) = stt(:,nt);
ptTb = pttb(sst*(nt-1)+1:sst*nt,1:sst);

for tt = 1:nt-1
ptt = pttb(sst*(nt-tt-1)+1:sst*(nt-tt),1:sst); 
p1t = pt1b(sst*(nt-tt)+1:sst*(nt-tt+1),1:sst);
jt = ptt*F'/p1t;
stT(:,nt-tt) = stt(:,nt-tt) + jt*(stT(:,nt-tt+1)-st1(:,nt-tt+1));
ptT = ptt + jt*(ptTb(1:sst,1:sst)-p1t)*jt';
ptTb = [ptT ; ptTb];
end

%***********************************************
