function ll = likelihood_s2(param,yt,xy,xs,gpot0,bpot0)  

%
%   Set up Kalman Filter
%
%
%   y(t) = Axy(t) + Hs(t) + w(t)   =  observation equation, xy(t) is exogenous, predetermined variables
%
%   s(t) = Gxs(t) + Fs(t-1) + v(t)   -  state equation
%
%
%
%   In the program below, will use the following notation
%
%
%  stt = s(t|t), st1 = s(t|t-1) 
%  ptt = p(t|t), pt1 = p(t|t-1)
%  kt = Kalman gain
%  s00 = s(0|0) - initial estimate of state vector
%  p00 = p(0|0) - initial estiamte of uncertainty
%  Q = E(vv') - var/cov matrix of noise in state equation
%  R = E(ww') - var/cov matrix of noise in observation equation 

% initialize Kalman filter
%
% set initial condition for the Kalman filter
%


[A,H,R,G,F,Q]=Cmat_s2(param);

[nv, nt] = size(yt);

n1 = size(F,1);    % number of state variables        



    s00 = 100*[gpot0;bpot0];
    p00 = 0.2*eye(n1);
%    end;
    
  

% s00
% p00

st1 = zeros(n1,nt);
stt = zeros(n1,nt);
% et = zeros(nv,nt);
% ll = zeros(nt,1);
ll=0;

% if init == 1
% s00 = si00;
% p00 = pi00;
% else 

% xsmean=mean(xs');
% s00 = (eye(n1)-F)\G*xsmean';
% 
% %zeros(n1,1); % ???? use unconditional distribution !!!!!!not zero!!!!!
% Q00 = reshape(Q,n1^2,1);
% vecp00 = (eye(n1^2)- kron(F,F))\Q00;
% clear Q00;
% p00 = reshape(vecp00,n1,n1);
% clear vecp00
% end

st1(:,1) = F*s00+G*xs(:,1);   % !!!!!!!!!!!!!!!
pt1 = F*p00*F' + Q;

% ind = [];
% for ii = 1:size(missy,1)
%     if missy(ii,1) == 1 % missy = 1 if not missing.  You could alternatively use "if isnumeric(yt(ii,1))" and have the missing obs as "nan"
%         ind = [ind ii];
%     end
% end
% HPHR2=zeros(size(R));
HPHR=(H*pt1*H' + R);
HPHR2=inv(HPHR);

kt = pt1*H'*HPHR2;
stt(:,1) = st1(:,1) + kt*(yt(:,1)-H*st1(:,1)-A*xy(:,1)); %!!!!!!!!!!!1
ptt = pt1 - kt*H*pt1;
% pt1b = pt1;
% pttb=ptt;
% p7ttb = ptt;

wt(:,1) = yt(:,1)-H*st1(:,1)-A*xy(:,1);
ll=ll +.5*log(det(HPHR))+.5*(wt(:,1)'*HPHR2*wt(:,1)); % log likelihood

% vt(:,1) = stt(:,1)-F*s00(:,1)-G*xs(:,1); %Zv(t) !!!!!!!!!!!!!!!!
% vt(:,1) = vt(:,1);

% run Kalman filter

for tt = 2:nt;
st1(:,tt) = F*stt(:,tt-1)+G*xs(:,tt);   %!!!!!!!!!!!!!!!!!!!
pt1 = F*ptt*F' + Q;
% ind = [];
% for ii = 1:size(missy,1)
%     if missy(ii,tt) == 1 % missy = 1 if not missing.  You could alternatively use if "isnumeric(yt(ii,tt))" and have the missing obs as "nan"
%         ind = [ind ii];
%     end
% end

HPHR=(H*pt1*H' + R);
HPHR2=inv(HPHR);

kt = pt1*H'*HPHR2;
stt(:,tt) = st1(:,tt) + kt*(yt(:,tt)-H*st1(:,tt)-A*xy(:,tt)) ; %!!!!!!!!!!!!!!
ptt = pt1 - kt*H*pt1;
% pt1b = [pt1b ; pt1];
% pttb = [pttb ; ptt];
wt(:,tt) = yt(:,tt)-H*st1(:,tt)-A*xy(:,tt);          %!!!!!!!!!!!!!!!!!!
ll = ll+.5*log(det(HPHR))+.5*(wt(:,tt)'*HPHR2*wt(:,tt)); % log likelihood

% vt(:,tt) = stt(:,tt)-F*stt(:,tt-1)-G*xs(:,tt); %Zv(t)     %!!!!!!!!!!!!!!!!!!!

end
