function [stT, lambda_z, param_s2,ll]=rstar_s2(y0, T0,nstart)

%%%%%%%%%%%%%%%%%%%%%%First Stage%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nar = 10;   %* Number of regressors *%
nsv = 4;   %* Number of state variables *%
nst = T0;   %* Startup periods for filter *%
nt=T0;
niter = 1000;   %* Number of draws for generating error bands *%
seed1 = 40;
indx = 0;  %* Index for initialisation of P(0|0) during MC simulation *%


% The starting values for measurement equation parameters are by OLS regression*/
% Starting values for transition equation are chosen

    
%     nt=size(yt,1);                % used to make trials

 %Potential XBO proxied by segmented trend 60:1 to 02:3 */
     xr=[ones(nt+4,1) [1:nt+4]'];
     xr=[xr, [zeros(nstart+4,1);[1:nt-nstart]'],[zeros(142,1);[1:nt-138]']];
     xi=inv(xr'*xr);
    bpot = xi*xr'*y0(nstart-3:nt+nstart,1);
    gpot = xr*bpot;
    gap = 100*(y0(nstart-3:nt+nstart,1)-xr*bpot);
    
    %* IS equation */
    yis = gap(5:nt+4);
    xis = [gap(4:nt+3),gap(3:nt+2), (y0(nstart:nt+nstart-1,6)+y0(nstart-1:nstart+nt-2,6))/2,ones(nt,1)];
    bis = (xis'*xis)\xis'*yis;
    ris = yis-xis*bis;
    sis = sqrt(ris'*ris/(nt-size(xis,2)));


    %* Phillips equation */
    yph = y0(nstart+1:nt+nstart,2);
    xph = [y0(nstart:nt+nstart-1,2),(y0(nstart-1:nt+nstart-2,2)+y0(nstart-2:nt+nstart-3,2)+y0(nstart-3:nt+nstart-4,2))/3]; % pi(t-2,t-4)
    xph = [xph,(y0(nstart-4:nt+nstart-5,2)+y0(nstart-5:nt+nstart-6,2)+y0(nstart-6:nt+nstart-7,2)+y0(nstart-7:nt+nstart-8,2))/4]; % pi(t-5,t-8)
    xph = [xph, gap(4:nt+3), y0(nstart:nt+nstart-1,4)];
    bph = (xph'*xph)\xph'*yph;
    rph = yph-xph*bph;
    sph = sqrt(rph'*rph/(nt-size(xph,2)));

    
  %* Transition equation std devs */
    s3 = 0.5;
    lam_g=0.03;                    %g = 0.85;
    
  % Constructing data matrices and vector of initial values */
    y = [100.*y0(nstart+1:nt+nstart,1),yph]';
    xy = [100.*[y0(nstart:nt+nstart-1,1), y0(nstart-1:nt+nstart-2,1)],y0(nstart:nt+nstart-1,6),y0(nstart-1:nt+nstart-2,6),xph(:,1:3),xph(:,5),ones(nt,1)]';
    xs=zeros(1,nt);
rhoy0=0.95;
param0_s2=[bis;-bis(3); bph([1,2,4,5]);sis;sph;s3;lam_g]';
%param0_s1=[a1 a2 b1 b2 b3 b4 b5 g sig1 sig2 sig4]; % initial value for stage 1 estimation

gpot0=gpot([5,4,3],:); bpot0=bpot(2);
%[A,H,R,G,F,Q]=Cmat_s2(param0_s2,lam_g);


%[ll,st1,stt,pt1b,pttb, s00 , p00] = kalfil_s2(param0_s2,y,xy,xs,gpot0,bpot0,lam_g);


% 
 param1_s2=param0_s2; 

%[param1_s2,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s2(Param,y,xy,xs,gpot0,bpot0),param0_s2,optimset('MaxIter',25000,'MaxFunEvals',30000))
 %[param2_s2,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s2(Param,y,xy,xs,gpot0,bpot0),param1_s2,optimset('MaxIter',25000,'MaxFunEvals',30000, 'TolFun',1e-8,'TolX',1e-8))

 

[param1_s2,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s2(Param,y,xy,xs,gpot0,bpot0),param0_s2,optimset('MaxIter',2000,'MaxFunEvals',10000))

[Param2,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s2(Param,y,xy,xs,gpot0,bpot0),param1_s2,optimset('MaxIter',2000,'MaxFunEvals',10000))

[liks,Paramsim,ghat,Hhat,itct,fcount,retcodehat]=csminwel('likelihood_s2',Param2,eye(size(Param2,2))*.1,[],1e-8,200,y,xy,xs,gpot0,bpot0);


options3=optimset('fminunc');
options2=optimset(options3,'MaxFunEvals',100000);
options22=optimset(options2,'TolX',1.0000e-006);
options222=optimset(options22,'TolFun',1.0000e-006);
options=optimset(options222,'MaxIter',1000)

%[Paramsim, fval, exitflag, output,grad,hessian] = fminunc('likelihood2newv2',Param2,options,yte,xy,n,p,q,f00,k00,includeslope);
[Paramminu, fval, exitflag, output,grad,hessian] = fminunc('likelihood_s2',Paramsim,options,y,xy,xs,gpot0,bpot0);
fval
exitflag
output
 
 
 
 % ll1 = likelihood_s1(param1_s1,y,xy,xs,gpot0)  
% 
% [liks,Paramsim,ghat,Hhat,itct,fcount,retcodehat]=csminwel('likelihood_s1',param1_s1,eye(size(param1_s1,2))*.1,[],1e-5,200,y,xy,xs,gpot0)
% 
% ll2 = likelihood_s1(Paramsim,y,xy,xs,gpot0)  
% 
% 
% [param0_s1' param1_s1' Paramsim']
% break
param_s2=Paramminu;         
[A,H,R,G,F,Q]=Cmat_s2(param_s2);
[ll,st1,stt,pt1b,pttb, s00 , p00] = kalfil_s2(param_s2,y,xy,xs,gpot0,bpot0);
[stT,ptTb] = KALSMOO(stt,st1,pttb,pt1b,F);

stin=stT(:,1);
ypot=[stin([3,2],:)',stT(1,:)]'; %stT(-1), stT(0) included
ygap=100*y0(nstart-1:nt+nstart,1)-ypot;



ydat=[ygap(3:nt+2,:), ygap(2:nt+1,:), ygap(1:nt,:), (xy(3,:)+xy(4,:))'/2,stT(4,:)' ];
lambda_z=lams2(ydat);


