function [stT, param_s3,param0_s3,ll, hessian, grad]=rstar_s3(y0, T0,nstart,lam_g,lambda_z)

%%%%%%%%%%%%%%%%%%%%%%First Stage%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nar = 9;   %* Number of regressors *%
nsv = 7;   %* Number of state variables *%
nst = T0;   %* Startup periods for filter *%
nt=T0;
niter = 1000;   %* Number of draws for generating error bands *%
seed1 = 40;
indx = 0;  %* Index for initialisation of P(0|0) during MC simulation *%


% The starting values for measurement equation parameters are by OLS regression*/
% Starting values for transition equation are chosen

    
%     nt=size(yt,1);                % used to make trials

 %Potential XBO proxied by segmented trend 60:1 to 02:3 */
     xr=[ones(nt+4,1) [1:nt+4]'];
     xr=[xr, [zeros(nstart+4,1);[1:nt-nstart]'],[zeros(142,1);[1:nt-138]']];
     xi=inv(xr'*xr);
    bpot = xi*xr'*y0(nstart-3:nt+nstart,1);
    gpot = xr*bpot;
    gap = 100*(y0(nstart-3:nt+nstart,1)-xr*bpot);

    
    %* IS equation */
    yis = gap(5:nt+4);
    xis = [gap(4:nt+3),gap(3:nt+2), (y0(nstart:nt+nstart-1,6)+y0(nstart-1:nstart+nt-2,6))/2,ones(nt,1)];
    bis = (xis'*xis)\xis'*yis;
    ris = yis-xis*bis;
    sis = sqrt(ris'*ris/(nt-size(xis,2)));


    %* Phillips equation */
    yph = y0(nstart+1:nt+nstart,2);
    xph = [y0(nstart:nt+nstart-1,2),(y0(nstart-1:nt+nstart-2,2)+y0(nstart-2:nt+nstart-3,2)+y0(nstart-3:nt+nstart-4,2))/3]; % pi(t-2,t-4)
    xph = [xph,(y0(nstart-4:nt+nstart-5,2)+y0(nstart-5:nt+nstart-6,2)+y0(nstart-6:nt+nstart-7,2)+y0(nstart-7:nt+nstart-8,2))/4]; % pi(t-5,t-8)
    xph = [xph, gap(4:nt+3), y0(nstart:nt+nstart-1,4)];
    bph = (xph'*xph)\xph'*yph;
    rph = yph-xph*bph;
    sph = sqrt(rph'*rph/(nt-size(xph,2)));

  %* Transition equation std devs */
    s3 = 0.7;
    d=4;
    
    s5=lam_g*s3;
    lam_z=lambda_z(1,3);                    %g = 0.85;
  % Constructing data matrices and vector of initial values */
    y = [100.*y0(nstart+1:nt+nstart,1),yph]';
    xy = [100.*[y0(nstart:nt+nstart-1,1), y0(nstart-1:nt+nstart-2,1)],y0(nstart:nt+nstart-1,6),y0(nstart-1:nt+nstart-2,6),xph(:,1:3),xph(:,5)]';
    xs=zeros(1,nt);

    
param0_s3=[bis(1:3); bph([1,2,4,5]);d;sis;sph;s3;s5]';
%save('test03','param0_s3')
%param0_s1=[a1 a2 b1 b2 b3 b4 b5 g sig1 sig2 sig4]; % initial value for stage 1 estimation
gpot0=gpot([5,4,3],:); bpot0=bpot(2);
[A,H,R,G,F,Q]=Cmat_s3(param0_s3, lam_z);

% break



% ll0 = likelihood_s1(param0_s1,y,xy,xs,gpot0)  
  param1_s3=param0_s3;

%[param1_s3,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s3(Param,y,xy,xs,gpot0,bpot0, lam_z),param0_s3,optimset('MaxIter',8000,'MaxFunEvals',10000))

%[Param2,fpval,exitflag,outputp]=fminsearch(@(Param) likelihood_s3(Param,y,xy,xs,gpot0,bpot0, lam_z),param1_s3,optimset('MaxIter',8000,'MaxFunEvals',10000))

%[liks,Paramsim,ghat,Hhat,itct,fcount,retcodehat]=csminwel('likelihood_s3',Param2,eye(size(Param2,2))*.1,[],1e-8,200,y,xy,xs,gpot0,bpot0,lam_z);


options3=optimset('fminunc');
options2=optimset(options3,'MaxFunEvals',100000);
options22=optimset(options2,'TolX',1.0000e-012);
options222=optimset(options22,'TolFun',1.0000e-012);
options=optimset(options222,'MaxIter',10000)

%[Paramsim, fval, exitflag, output,grad,hessian] = fminunc('likelihood2newv2',Param2,options,yte,xy,n,p,q,f00,k00,includeslope);

Paramsim=param0_s3;
[Paramminu, fval, exitflag, output,grad,hessian] = fminunc('likelihood_s3',Paramsim,options,y,xy,xs,gpot0,bpot0,lam_z);
fval
exitflag
output


param_s3=Paramminu;         
[A,H,R,G,F,Q]=Cmat_s3(param_s3,lam_z);
[ll,st1,stt,pt1b,pttb, s00 , p00] = kalfil_s3(param_s3,y,xy,xs,gpot0,bpot0,lam_z);
[stT,ptTb] = KALSMOO(stt,st1,pttb,pt1b,F);




