clear;
clc;
close all;

%********************************************
% Input:    raw data
% Output:   Aggregate Output; Inflation; Interest Rate

% 1 Canada
% 2 France
% 3 Germany
% 4 Italy
% 5 Japan
% 6 United Kingdom
% 7 United States
% 8 Australia
% 9 Austria
% 10Belgium
% 11Finland
% 12Greece
% 13Ireland
% 14Netherland
% 15Norway
% 16Portugal
% 17South Korea
% 18Spain
% 19Sweden
% 20Switzerland
%
%  
%************************************************************
clear;
clc;
close all;


ind=xlsread('data160614.xlsx','Intro');       % Used to splice data, no need to update it.
ncoun=size(ind,1);              % number of countries




%*********GDP aggregation and GDP share after 1960*****************

ind_gdp=ind(:,1); % indicate which gdp needs to be spliced and when.

gdp_end=1;                    % if gdp_end=0, the GDP in all countries has been updated to the most recent period
                              % if gdp_end=1, the GDP in all countries has been updated to one period before the most recent period

[gdpt, gdpshare]=gdpagg(ind_gdp,gdp_end); % total GDP and gdpshare before  1960

%****************************************************************

%*******************nominal interest rate aggregation************

ind_eur=ind(:,4);
ind_64=ind(:,5);      % in some countries, the data before 1964 are missing
itr_end=1;            % if itr_end=1, it means the latest interest rate data available is one quarter after the most recent GDP
                      % interest rate is released every day, so sometimes itr_end could be 2.
nitrt=intagg(gdpshare, ind_eur,ind_64, itr_end);

%find(isnan(nitrt))

%*********************Inflation********************************

inf_end=1;

core_beg=1955.25;
core_start=1958.25;

sp_yr=ind(:,3);
gdpshare60=gdpshare;

save('gdpshare','gdpshare60') 
infavg=infagg(gdpshare, sp_yr, inf_end, core_beg, core_start);

%infavg=infagg(gdpshare, sp_yr, inf_end, core_beg,core_start);
%infavg=infagg(gdpshare, sp_yr, inf_end, core_beg, core_start);

xlswrite('dataagg160619_sheet1.xlsx',infavg,'coreinflation');
xlswrite('dataagg160619_sheet1.xlsx',gdpt,'gdp');
xlswrite('dataagg160619_sheet1.xlsx',nitrt,'policyrate')









